// ==========================================
//  GCOE G2 Process Manager v0.3
//  Part of GCOE G2 System 1.0
// ==========================================

// ==[ meta declares ]=======================

  #dim program.data, 0
  #dim program.byteposition, 1
  #dim program.id, 2
  #dim program.active, 3
  #dim program.filename, 4
  #dim window.zorder, 5
  #dim window.left, 6
  #dim window.top, 7
  #dim window.width, 8
  #dim window.height, 9
  #dim window.caption, 10
  #dim window.resize, 11

  // refresh:
  #dim windowcontrols.left2, 16
  #dim windowcontrols.left, 17

// ==[ program ]=============================

[program]
[/program]

// ==[ mouse press ]=========================

[mouseshow]
  // position and draw the window control buttons
  math _windowcontrols.left, window.width, -, 58
  math _windowcontrols.left2, window.width, -, 29

  // note: negitive numbers must be inside quotes or
  // the compiler reads - as a command.
  click windowcontrols.left, "-22", 23, 6
    mouseclear
    buttondown windowcontrols.left, "-22", 23, 6, ""
    mouserefresh
  endclick
  click windowcontrols.left, "-11", 23, 6
    mouseclear
    buttondown windowcontrols.left, "-11", 23, 6, ""
    mouserefresh
  endclick
  click windowcontrols.left2, "-22", 23, 6
    mouseclear
    buttondown windowcontrols.left2, "-22", 23, 6, ""
    mouserefresh
  endclick
  click windowcontrols.left2, "-11", 23, 6
    mouseclear
    buttondown windowcontrols.left2, "-11", 23, 6, "-"
    mouserefresh
  endclick
[/mouseshow]

// ==[ mouse release ]=======================

[mousehide]
  mouseclear
  buttonup windowcontrols.left, "-22", 23, 6, ""
  buttonup windowcontrols.left, "-11", 23, 6, ""
  buttonup windowcontrols.left2, "-22", 23, 6, ""
  buttonup windowcontrols.left2, "-11", 23, 6, "-"
  mouserefresh
[/mousehide]

// ==[ refresh ]=============================

[redraw]
  // redraw the window
  redrawWindow

  // position and draw the window control buttons
  math _windowcontrols.left, window.width, -, 58
  math _windowcontrols.left2, window.width, -, 29

  // note: negitive numbers must be inside quotes or
  // the compiler reads - as a command.
  if window.zorder != 20
    // this makes them look darker if the window is not
    // the topmost.
    buttondown windowcontrols.left, "-22", 23, 6, ""
    buttondown windowcontrols.left, "-11", 23, 6, ""
    buttondown windowcontrols.left2, "-22", 23, 6, ""
    buttondown windowcontrols.left2, "-11", 23, 6, "-"
  else
    buttonup windowcontrols.left, "-22", 23, 6, ""
    buttonup windowcontrols.left, "-11", 23, 6, ""
    buttonup windowcontrols.left2, "-22", 23, 6, ""
    buttonup windowcontrols.left2, "-11", 23, 6, "-"
  endif
[/redraw]

// ==[ init ]================================

[header]
  // set window position on screen
  set _window.left, 40
  set _window.top, 40
  set _window.width, 300
  set _window.height, 300
  set _window.caption, "Process Manager"
[/header]